structure Tiere = Peirce(
  datatype element = a1 | a2 | a3      (* Ameisen *)
                   | e1 | e2 | e3 | e4 (* Elephanten *)
                   | h1 | h2 | h3 | h4 (* Hunde *)
  val elements = 
              [a1,a2,a3,h1,h2,h3,h4,e1,e2,e3,e4]
  exception NoValue

  fun ConS "arbeiten" = [a1,a2]
    | ConS "gesund"   = [a1,a3,e2,e3,h1,h4]
    | ConS "Ameise"   = [a1,a2,a3]
    | ConS "Elephant" = [e1,e2,e3,e4]
    | ConS "Hund"     = [h1,h2,h3,h4]
    | ConS "weiß"     = [a1,a2,e1,e2,h1,h3,h4]
    | ConS "Tier"     = elements
    | ConS _ = raise NoValue

  fun ConR "größer" = 
              [(e4,e2),(e3,e2),(e2,e1),   (* partiell *) 
               (h4,h3),(h3,h2),(h2,h1), 
               (a3,a2),(a2,a1),           (* total *)
               (e1,h4),(h1,a3)]
    | ConR "kleiner"  = 
      map (fn (x,y) => (y,x)) (ConR "größer")
    | ConR _ = raise NoValue
 )

structure NL3 : PARSE = Parse(structure Algebra = Tiere)
